#!/bin/csh -f
# Script to run the program unresCSA on linux with MPICH/PBS (parallel version).
#
# This example script pertains to the ALPHABETA force field (see section 4 of the 
# description). 

# The GB potentials is used with the ALPHABETA force field; DO NOT change the line below.
setenv POT GB

# The line below defines the system-specific input file; the example is for 1IGD.
setenv PREFIX betanova_alphabeta

# Define the location of UNRES parameter file and binaries directory.
set DD = /users/adam/UNRES/PARAM
set BIN = /users/czarek/UNRES/NEW/bin
#---------------------------------
setenv THETPAR $DD/thetaml.5parm
setenv ROTPAR $DD/scgauss.parm
setenv TORPAR $DD/torsion_ecepp.parm
setenv TORDPAR $DD/torsion_double_631Gdp.parm
setenv ELEPAR $DD/electr.parm
setenv SIDEPAR $DD/scinter_GB.parm
setenv FOURIER $DD/fourier_GAP.parm
setenv SCPPAR $DD/scp.parm

# Pattern database
setenv PATTERN $DD/patterns.cart
#--------------------------------------------

endif

set DEBUG = 0

$BIN/unres_pgf90_moment.exe $*

if ("$3" != "-p4amslave") then
# Remove links
/bin/rm fort.*
# Clear empty files
find . -size 0 -exec rm {} \;
endif

